#reset
execute as @a run attribute @s minecraft:generic.gravity base set 0.08
scoreboard players set @a[scores={ground=1}] wjcd 10

#ground detect/wj chain
execute as @a[nbt={OnGround:0b}] run scoreboard players set @s ground 0
execute as @a[nbt={OnGround:1b}] run scoreboard players set @s ground 1
execute as @a[nbt={OnGround:1b}] run scoreboard players set @s wjchain 0

#sneakjump
execute as @a[scores={ground=1, sneak=1.., wjchain=0, climbing=0, sprint=0}] run effect give @s jump_boost 1 1 true

#wallrun
execute as @a[nbt={OnGround:0b}] at @s unless block ^-0.5 ^ ^ minecraft:air unless block ^-0.5 ^ ^ minecraft:water unless block ^-0.5 ^ ^ minecraft:blue_ice run attribute @s minecraft:generic.gravity base set 0.039
execute as @a[nbt={OnGround:0b}] at @s unless block ^0.5 ^ ^ minecraft:air unless block ^0.5 ^ ^ minecraft:water unless block ^0.5 ^ ^ minecraft:blue_ice run attribute @s minecraft:generic.gravity base set 0.039
execute as @a[nbt={OnGround:0b}] at @s unless block ^ ^ ^-0.9 minecraft:air unless block ^ ^ ^-0.9 minecraft:water unless block ^ ^ ^-0.9 minecraft:blue_ice run attribute @s minecraft:generic.gravity base set 0.039
execute as @a at @s if block ^-0.7 ^ ^ minecraft:air run execute as @s at @s if block ^0.7 ^ ^ minecraft:air run attribute @s minecraft:generic.gravity base set 0.08
execute as @a[nbt={Attributes:[{Base: 0.039d, Name: "minecraft:generic.gravity"}]}, scores={wallhangtime=1..}] run function prkr:wallhang
execute as @a[nbt={Attributes:[{Base: 0.08d, Name: "minecraft:generic.gravity"}]}] run scoreboard players set @s wallhangtime 5

#climbing
execute as @a[scores={climbing=1..}] run scoreboard players set @s climbing 0
execute as @a[scores={ground=0, sneak=1, wjcd=0}] at @s unless block ^ ^ ^0.335 minecraft:air unless block ^ ^ ^0.335 minecraft:blue_ice run attribute @s minecraft:generic.gravity base set -0.0025
execute as @a[scores={ground=0, sneak=1, wjcd=0}] at @s unless block ^ ^ ^0.335 minecraft:air unless block ^ ^ ^0.335 minecraft:blue_ice run scoreboard players set @s climbing 1

#wallrun fall dmg
execute as @a at @s if block ^-0.7 ^ ^ minecraft:air run execute as @s at @s if block ^0.7 ^ ^ minecraft:air run execute as @s run attribute @s minecraft:generic.fall_damage_multiplier base set 1
execute as @a at @s unless block ^-0.4 ^ ^ minecraft:air unless block ^-0.4 ^ ^ minecraft:water run attribute @s minecraft:generic.fall_damage_multiplier base set 0
execute as @a at @s unless block ^-0.4 ^ ^ minecraft:air unless block ^0.4 ^ ^ minecraft:water run attribute @s minecraft:generic.fall_damage_multiplier base set 0
execute as @a at @s unless block ^ ^ ^-0.7 minecraft:air unless block ^ ^ ^-0.9 minecraft:water run attribute @s minecraft:generic.fall_damage_multiplier base set 0

#sprinting
execute as @a[scores={sprint=0}] run scoreboard players set @s sprintDist 0
execute as @a[scores={ground=1}] as @s[scores={sprint=1..}] run scoreboard players set @s sprint 0
execute as @a[scores={sprintDist=2000..5000}] run effect give @s speed 1 0
execute as @a[scores={sprintDist=5000..7000}] run effect give @s speed 1 1
execute as @a[scores={sprintDist=7000..}] run effect give @s speed 2 1


#walljump
execute as @a at @s unless block ^-0.7 ^ ^ minecraft:air unless block ^-0.7 ^ ^ minecraft:blue_ice run execute as @s[scores={sneak=1.., wjcd=0, ground=0, climbing=0}] at @s run function prkr:walljump
execute as @a at @s unless block ^ ^ ^-0.9 minecraft:air unless block ^ ^ ^-0.9 minecraft:blue_ice run execute as @s[scores={sneak=1.., wjcd=0, ground=0, climbing=0}] at @s run function prkr:walljump
execute as @a at @s unless block ^0.7 ^ ^ minecraft:air unless block ^0.7 ^ ^ minecraft:blue_ice run execute as @s[scores={sneak=1.., wjcd=0, ground=0, climbing=0}] at @s run function prkr:walljump
execute as @a[scores={sneak=1..}] run scoreboard players set @s sneak 0
execute as @a[scores={wjcd=1..}] run scoreboard players remove @s wjcd 1
execute as @a at @s if block ^-0.9 ^ ^ minecraft:air run execute as @s at @s if block ^0.9 ^ ^ minecraft:air run scoreboard players set @s[scores={wjcd=3..}] wjcd 3